/**
 * @license
 * Copyright 2019 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const et = globalThis, dt = et.ShadowRoot && (et.ShadyCSS === void 0 || et.ShadyCSS.nativeShadow) && "adoptedStyleSheets" in Document.prototype && "replace" in CSSStyleSheet.prototype, zt = Symbol(), bt = /* @__PURE__ */ new WeakMap();
let Lt = class {
  constructor(t, e, r) {
    if (this._$cssResult$ = !0, r !== zt)
      throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");
    this.cssText = t, this.t = e;
  }
  get styleSheet() {
    let t = this.o;
    const e = this.t;
    if (dt && t === void 0) {
      const r = e !== void 0 && e.length === 1;
      r && (t = bt.get(e)), t === void 0 && ((this.o = t = new CSSStyleSheet()).replaceSync(this.cssText), r && bt.set(e, t));
    }
    return t;
  }
  toString() {
    return this.cssText;
  }
};
const N = (i) => new Lt(typeof i == "string" ? i : i + "", void 0, zt), Dt = (i, t) => {
  if (dt)
    i.adoptedStyleSheets = t.map((e) => e instanceof CSSStyleSheet ? e : e.styleSheet);
  else
    for (const e of t) {
      const r = document.createElement("style"), o = et.litNonce;
      o !== void 0 && r.setAttribute("nonce", o), r.textContent = e.cssText, i.appendChild(r);
    }
}, mt = dt ? (i) => i : (i) => i instanceof CSSStyleSheet ? ((t) => {
  let e = "";
  for (const r of t.cssRules)
    e += r.cssText;
  return N(e);
})(i) : i;
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const { is: jt, defineProperty: It, getOwnPropertyDescriptor: Wt, getOwnPropertyNames: Yt, getOwnPropertySymbols: Ft, getPrototypeOf: Vt } = Object, z = globalThis, vt = z.trustedTypes, qt = vt ? vt.emptyScript : "", nt = z.reactiveElementPolyfillSupport, Y = (i, t) => i, rt = { toAttribute(i, t) {
  switch (t) {
    case Boolean:
      i = i ? qt : null;
      break;
    case Object:
    case Array:
      i = i == null ? i : JSON.stringify(i);
  }
  return i;
}, fromAttribute(i, t) {
  let e = i;
  switch (t) {
    case Boolean:
      e = i !== null;
      break;
    case Number:
      e = i === null ? null : Number(i);
      break;
    case Object:
    case Array:
      try {
        e = JSON.parse(i);
      } catch {
        e = null;
      }
  }
  return e;
} }, pt = (i, t) => !jt(i, t), yt = { attribute: !0, type: String, converter: rt, reflect: !1, hasChanged: pt };
Symbol.metadata ?? (Symbol.metadata = Symbol("metadata")), z.litPropertyMetadata ?? (z.litPropertyMetadata = /* @__PURE__ */ new WeakMap());
class H extends HTMLElement {
  static addInitializer(t) {
    this._$Ei(), (this.l ?? (this.l = [])).push(t);
  }
  static get observedAttributes() {
    return this.finalize(), this._$Eh && [...this._$Eh.keys()];
  }
  static createProperty(t, e = yt) {
    if (e.state && (e.attribute = !1), this._$Ei(), this.elementProperties.set(t, e), !e.noAccessor) {
      const r = Symbol(), o = this.getPropertyDescriptor(t, r, e);
      o !== void 0 && It(this.prototype, t, o);
    }
  }
  static getPropertyDescriptor(t, e, r) {
    const { get: o, set: s } = Wt(this.prototype, t) ?? { get() {
      return this[e];
    }, set(n) {
      this[e] = n;
    } };
    return { get() {
      return o == null ? void 0 : o.call(this);
    }, set(n) {
      const c = o == null ? void 0 : o.call(this);
      s.call(this, n), this.requestUpdate(t, c, r);
    }, configurable: !0, enumerable: !0 };
  }
  static getPropertyOptions(t) {
    return this.elementProperties.get(t) ?? yt;
  }
  static _$Ei() {
    if (this.hasOwnProperty(Y("elementProperties")))
      return;
    const t = Vt(this);
    t.finalize(), t.l !== void 0 && (this.l = [...t.l]), this.elementProperties = new Map(t.elementProperties);
  }
  static finalize() {
    if (this.hasOwnProperty(Y("finalized")))
      return;
    if (this.finalized = !0, this._$Ei(), this.hasOwnProperty(Y("properties"))) {
      const e = this.properties, r = [...Yt(e), ...Ft(e)];
      for (const o of r)
        this.createProperty(o, e[o]);
    }
    const t = this[Symbol.metadata];
    if (t !== null) {
      const e = litPropertyMetadata.get(t);
      if (e !== void 0)
        for (const [r, o] of e)
          this.elementProperties.set(r, o);
    }
    this._$Eh = /* @__PURE__ */ new Map();
    for (const [e, r] of this.elementProperties) {
      const o = this._$Eu(e, r);
      o !== void 0 && this._$Eh.set(o, e);
    }
    this.elementStyles = this.finalizeStyles(this.styles);
  }
  static finalizeStyles(t) {
    const e = [];
    if (Array.isArray(t)) {
      const r = new Set(t.flat(1 / 0).reverse());
      for (const o of r)
        e.unshift(mt(o));
    } else
      t !== void 0 && e.push(mt(t));
    return e;
  }
  static _$Eu(t, e) {
    const r = e.attribute;
    return r === !1 ? void 0 : typeof r == "string" ? r : typeof t == "string" ? t.toLowerCase() : void 0;
  }
  constructor() {
    super(), this._$Ep = void 0, this.isUpdatePending = !1, this.hasUpdated = !1, this._$Em = null, this._$Ev();
  }
  _$Ev() {
    var t;
    this._$ES = new Promise((e) => this.enableUpdating = e), this._$AL = /* @__PURE__ */ new Map(), this._$E_(), this.requestUpdate(), (t = this.constructor.l) == null || t.forEach((e) => e(this));
  }
  addController(t) {
    var e;
    (this._$EO ?? (this._$EO = /* @__PURE__ */ new Set())).add(t), this.renderRoot !== void 0 && this.isConnected && ((e = t.hostConnected) == null || e.call(t));
  }
  removeController(t) {
    var e;
    (e = this._$EO) == null || e.delete(t);
  }
  _$E_() {
    const t = /* @__PURE__ */ new Map(), e = this.constructor.elementProperties;
    for (const r of e.keys())
      this.hasOwnProperty(r) && (t.set(r, this[r]), delete this[r]);
    t.size > 0 && (this._$Ep = t);
  }
  createRenderRoot() {
    const t = this.shadowRoot ?? this.attachShadow(this.constructor.shadowRootOptions);
    return Dt(t, this.constructor.elementStyles), t;
  }
  connectedCallback() {
    var t;
    this.renderRoot ?? (this.renderRoot = this.createRenderRoot()), this.enableUpdating(!0), (t = this._$EO) == null || t.forEach((e) => {
      var r;
      return (r = e.hostConnected) == null ? void 0 : r.call(e);
    });
  }
  enableUpdating(t) {
  }
  disconnectedCallback() {
    var t;
    (t = this._$EO) == null || t.forEach((e) => {
      var r;
      return (r = e.hostDisconnected) == null ? void 0 : r.call(e);
    });
  }
  attributeChangedCallback(t, e, r) {
    this._$AK(t, r);
  }
  _$EC(t, e) {
    var s;
    const r = this.constructor.elementProperties.get(t), o = this.constructor._$Eu(t, r);
    if (o !== void 0 && r.reflect === !0) {
      const n = (((s = r.converter) == null ? void 0 : s.toAttribute) !== void 0 ? r.converter : rt).toAttribute(e, r.type);
      this._$Em = t, n == null ? this.removeAttribute(o) : this.setAttribute(o, n), this._$Em = null;
    }
  }
  _$AK(t, e) {
    var s;
    const r = this.constructor, o = r._$Eh.get(t);
    if (o !== void 0 && this._$Em !== o) {
      const n = r.getPropertyOptions(o), c = typeof n.converter == "function" ? { fromAttribute: n.converter } : ((s = n.converter) == null ? void 0 : s.fromAttribute) !== void 0 ? n.converter : rt;
      this._$Em = o, this[o] = c.fromAttribute(e, n.type), this._$Em = null;
    }
  }
  requestUpdate(t, e, r) {
    if (t !== void 0) {
      if (r ?? (r = this.constructor.getPropertyOptions(t)), !(r.hasChanged ?? pt)(this[t], e))
        return;
      this.P(t, e, r);
    }
    this.isUpdatePending === !1 && (this._$ES = this._$ET());
  }
  P(t, e, r) {
    this._$AL.has(t) || this._$AL.set(t, e), r.reflect === !0 && this._$Em !== t && (this._$Ej ?? (this._$Ej = /* @__PURE__ */ new Set())).add(t);
  }
  async _$ET() {
    this.isUpdatePending = !0;
    try {
      await this._$ES;
    } catch (e) {
      Promise.reject(e);
    }
    const t = this.scheduleUpdate();
    return t != null && await t, !this.isUpdatePending;
  }
  scheduleUpdate() {
    return this.performUpdate();
  }
  performUpdate() {
    var r;
    if (!this.isUpdatePending)
      return;
    if (!this.hasUpdated) {
      if (this.renderRoot ?? (this.renderRoot = this.createRenderRoot()), this._$Ep) {
        for (const [s, n] of this._$Ep)
          this[s] = n;
        this._$Ep = void 0;
      }
      const o = this.constructor.elementProperties;
      if (o.size > 0)
        for (const [s, n] of o)
          n.wrapped !== !0 || this._$AL.has(s) || this[s] === void 0 || this.P(s, this[s], n);
    }
    let t = !1;
    const e = this._$AL;
    try {
      t = this.shouldUpdate(e), t ? (this.willUpdate(e), (r = this._$EO) == null || r.forEach((o) => {
        var s;
        return (s = o.hostUpdate) == null ? void 0 : s.call(o);
      }), this.update(e)) : this._$EU();
    } catch (o) {
      throw t = !1, this._$EU(), o;
    }
    t && this._$AE(e);
  }
  willUpdate(t) {
  }
  _$AE(t) {
    var e;
    (e = this._$EO) == null || e.forEach((r) => {
      var o;
      return (o = r.hostUpdated) == null ? void 0 : o.call(r);
    }), this.hasUpdated || (this.hasUpdated = !0, this.firstUpdated(t)), this.updated(t);
  }
  _$EU() {
    this._$AL = /* @__PURE__ */ new Map(), this.isUpdatePending = !1;
  }
  get updateComplete() {
    return this.getUpdateComplete();
  }
  getUpdateComplete() {
    return this._$ES;
  }
  shouldUpdate(t) {
    return !0;
  }
  update(t) {
    this._$Ej && (this._$Ej = this._$Ej.forEach((e) => this._$EC(e, this[e]))), this._$EU();
  }
  updated(t) {
  }
  firstUpdated(t) {
  }
}
H.elementStyles = [], H.shadowRootOptions = { mode: "open" }, H[Y("elementProperties")] = /* @__PURE__ */ new Map(), H[Y("finalized")] = /* @__PURE__ */ new Map(), nt == null || nt({ ReactiveElement: H }), (z.reactiveElementVersions ?? (z.reactiveElementVersions = [])).push("2.0.4");
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const F = globalThis, it = F.trustedTypes, $t = it ? it.createPolicy("lit-html", { createHTML: (i) => i }) : void 0, Ot = "$lit$", P = `lit$${(Math.random() + "").slice(9)}$`, Tt = "?" + P, Jt = `<${Tt}>`, M = document, q = () => M.createComment(""), J = (i) => i === null || typeof i != "object" && typeof i != "function", Bt = Array.isArray, Kt = (i) => Bt(i) || typeof (i == null ? void 0 : i[Symbol.iterator]) == "function", at = `[ 	
\f\r]`, W = /<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g, wt = /-->/g, _t = />/g, B = RegExp(`>|${at}(?:([^\\s"'>=/]+)(${at}*=${at}*(?:[^ 	
\f\r"'\`<>=]|("|')|))|$)`, "g"), xt = /'/g, At = /"/g, Ut = /^(?:script|style|textarea|title)$/i, Zt = (i) => (t, ...e) => ({ _$litType$: i, strings: t, values: e }), y = Zt(1), O = Symbol.for("lit-noChange"), d = Symbol.for("lit-nothing"), kt = /* @__PURE__ */ new WeakMap(), U = M.createTreeWalker(M, 129);
function Mt(i, t) {
  if (!Array.isArray(i) || !i.hasOwnProperty("raw"))
    throw Error("invalid template strings array");
  return $t !== void 0 ? $t.createHTML(t) : t;
}
const Qt = (i, t) => {
  const e = i.length - 1, r = [];
  let o, s = t === 2 ? "<svg>" : "", n = W;
  for (let c = 0; c < e; c++) {
    const l = i[c];
    let p, u, h = -1, S = 0;
    for (; S < l.length && (n.lastIndex = S, u = n.exec(l), u !== null); )
      S = n.lastIndex, n === W ? u[1] === "!--" ? n = wt : u[1] !== void 0 ? n = _t : u[2] !== void 0 ? (Ut.test(u[2]) && (o = RegExp("</" + u[2], "g")), n = B) : u[3] !== void 0 && (n = B) : n === B ? u[0] === ">" ? (n = o ?? W, h = -1) : u[1] === void 0 ? h = -2 : (h = n.lastIndex - u[2].length, p = u[1], n = u[3] === void 0 ? B : u[3] === '"' ? At : xt) : n === At || n === xt ? n = B : n === wt || n === _t ? n = W : (n = B, o = void 0);
    const E = n === B && i[c + 1].startsWith("/>") ? " " : "";
    s += n === W ? l + Jt : h >= 0 ? (r.push(p), l.slice(0, h) + Ot + l.slice(h) + P + E) : l + P + (h === -2 ? c : E);
  }
  return [Mt(i, s + (i[e] || "<?>") + (t === 2 ? "</svg>" : "")), r];
};
class K {
  constructor({ strings: t, _$litType$: e }, r) {
    let o;
    this.parts = [];
    let s = 0, n = 0;
    const c = t.length - 1, l = this.parts, [p, u] = Qt(t, e);
    if (this.el = K.createElement(p, r), U.currentNode = this.el.content, e === 2) {
      const h = this.el.content.firstChild;
      h.replaceWith(...h.childNodes);
    }
    for (; (o = U.nextNode()) !== null && l.length < c; ) {
      if (o.nodeType === 1) {
        if (o.hasAttributes())
          for (const h of o.getAttributeNames())
            if (h.endsWith(Ot)) {
              const S = u[n++], E = o.getAttribute(h).split(P), tt = /([.?@])?(.*)/.exec(S);
              l.push({ type: 1, index: s, name: tt[2], strings: E, ctor: tt[1] === "." ? Xt : tt[1] === "?" ? te : tt[1] === "@" ? ee : st }), o.removeAttribute(h);
            } else
              h.startsWith(P) && (l.push({ type: 6, index: s }), o.removeAttribute(h));
        if (Ut.test(o.tagName)) {
          const h = o.textContent.split(P), S = h.length - 1;
          if (S > 0) {
            o.textContent = it ? it.emptyScript : "";
            for (let E = 0; E < S; E++)
              o.append(h[E], q()), U.nextNode(), l.push({ type: 2, index: ++s });
            o.append(h[S], q());
          }
        }
      } else if (o.nodeType === 8)
        if (o.data === Tt)
          l.push({ type: 2, index: s });
        else {
          let h = -1;
          for (; (h = o.data.indexOf(P, h + 1)) !== -1; )
            l.push({ type: 7, index: s }), h += P.length - 1;
        }
      s++;
    }
  }
  static createElement(t, e) {
    const r = M.createElement("template");
    return r.innerHTML = t, r;
  }
}
function L(i, t, e = i, r) {
  var n, c;
  if (t === O)
    return t;
  let o = r !== void 0 ? (n = e._$Co) == null ? void 0 : n[r] : e._$Cl;
  const s = J(t) ? void 0 : t._$litDirective$;
  return (o == null ? void 0 : o.constructor) !== s && ((c = o == null ? void 0 : o._$AO) == null || c.call(o, !1), s === void 0 ? o = void 0 : (o = new s(i), o._$AT(i, e, r)), r !== void 0 ? (e._$Co ?? (e._$Co = []))[r] = o : e._$Cl = o), o !== void 0 && (t = L(i, o._$AS(i, t.values), o, r)), t;
}
class Gt {
  constructor(t, e) {
    this._$AV = [], this._$AN = void 0, this._$AD = t, this._$AM = e;
  }
  get parentNode() {
    return this._$AM.parentNode;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  u(t) {
    const { el: { content: e }, parts: r } = this._$AD, o = ((t == null ? void 0 : t.creationScope) ?? M).importNode(e, !0);
    U.currentNode = o;
    let s = U.nextNode(), n = 0, c = 0, l = r[0];
    for (; l !== void 0; ) {
      if (n === l.index) {
        let p;
        l.type === 2 ? p = new Z(s, s.nextSibling, this, t) : l.type === 1 ? p = new l.ctor(s, l.name, l.strings, this, t) : l.type === 6 && (p = new re(s, this, t)), this._$AV.push(p), l = r[++c];
      }
      n !== (l == null ? void 0 : l.index) && (s = U.nextNode(), n++);
    }
    return U.currentNode = M, o;
  }
  p(t) {
    let e = 0;
    for (const r of this._$AV)
      r !== void 0 && (r.strings !== void 0 ? (r._$AI(t, r, e), e += r.strings.length - 2) : r._$AI(t[e])), e++;
  }
}
class Z {
  get _$AU() {
    var t;
    return ((t = this._$AM) == null ? void 0 : t._$AU) ?? this._$Cv;
  }
  constructor(t, e, r, o) {
    this.type = 2, this._$AH = d, this._$AN = void 0, this._$AA = t, this._$AB = e, this._$AM = r, this.options = o, this._$Cv = (o == null ? void 0 : o.isConnected) ?? !0;
  }
  get parentNode() {
    let t = this._$AA.parentNode;
    const e = this._$AM;
    return e !== void 0 && (t == null ? void 0 : t.nodeType) === 11 && (t = e.parentNode), t;
  }
  get startNode() {
    return this._$AA;
  }
  get endNode() {
    return this._$AB;
  }
  _$AI(t, e = this) {
    t = L(this, t, e), J(t) ? t === d || t == null || t === "" ? (this._$AH !== d && this._$AR(), this._$AH = d) : t !== this._$AH && t !== O && this._(t) : t._$litType$ !== void 0 ? this.$(t) : t.nodeType !== void 0 ? this.T(t) : Kt(t) ? this.k(t) : this._(t);
  }
  S(t) {
    return this._$AA.parentNode.insertBefore(t, this._$AB);
  }
  T(t) {
    this._$AH !== t && (this._$AR(), this._$AH = this.S(t));
  }
  _(t) {
    this._$AH !== d && J(this._$AH) ? this._$AA.nextSibling.data = t : this.T(M.createTextNode(t)), this._$AH = t;
  }
  $(t) {
    var s;
    const { values: e, _$litType$: r } = t, o = typeof r == "number" ? this._$AC(t) : (r.el === void 0 && (r.el = K.createElement(Mt(r.h, r.h[0]), this.options)), r);
    if (((s = this._$AH) == null ? void 0 : s._$AD) === o)
      this._$AH.p(e);
    else {
      const n = new Gt(o, this), c = n.u(this.options);
      n.p(e), this.T(c), this._$AH = n;
    }
  }
  _$AC(t) {
    let e = kt.get(t.strings);
    return e === void 0 && kt.set(t.strings, e = new K(t)), e;
  }
  k(t) {
    Bt(this._$AH) || (this._$AH = [], this._$AR());
    const e = this._$AH;
    let r, o = 0;
    for (const s of t)
      o === e.length ? e.push(r = new Z(this.S(q()), this.S(q()), this, this.options)) : r = e[o], r._$AI(s), o++;
    o < e.length && (this._$AR(r && r._$AB.nextSibling, o), e.length = o);
  }
  _$AR(t = this._$AA.nextSibling, e) {
    var r;
    for ((r = this._$AP) == null ? void 0 : r.call(this, !1, !0, e); t && t !== this._$AB; ) {
      const o = t.nextSibling;
      t.remove(), t = o;
    }
  }
  setConnected(t) {
    var e;
    this._$AM === void 0 && (this._$Cv = t, (e = this._$AP) == null || e.call(this, t));
  }
}
class st {
  get tagName() {
    return this.element.tagName;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  constructor(t, e, r, o, s) {
    this.type = 1, this._$AH = d, this._$AN = void 0, this.element = t, this.name = e, this._$AM = o, this.options = s, r.length > 2 || r[0] !== "" || r[1] !== "" ? (this._$AH = Array(r.length - 1).fill(new String()), this.strings = r) : this._$AH = d;
  }
  _$AI(t, e = this, r, o) {
    const s = this.strings;
    let n = !1;
    if (s === void 0)
      t = L(this, t, e, 0), n = !J(t) || t !== this._$AH && t !== O, n && (this._$AH = t);
    else {
      const c = t;
      let l, p;
      for (t = s[0], l = 0; l < s.length - 1; l++)
        p = L(this, c[r + l], e, l), p === O && (p = this._$AH[l]), n || (n = !J(p) || p !== this._$AH[l]), p === d ? t = d : t !== d && (t += (p ?? "") + s[l + 1]), this._$AH[l] = p;
    }
    n && !o && this.j(t);
  }
  j(t) {
    t === d ? this.element.removeAttribute(this.name) : this.element.setAttribute(this.name, t ?? "");
  }
}
class Xt extends st {
  constructor() {
    super(...arguments), this.type = 3;
  }
  j(t) {
    this.element[this.name] = t === d ? void 0 : t;
  }
}
class te extends st {
  constructor() {
    super(...arguments), this.type = 4;
  }
  j(t) {
    this.element.toggleAttribute(this.name, !!t && t !== d);
  }
}
class ee extends st {
  constructor(t, e, r, o, s) {
    super(t, e, r, o, s), this.type = 5;
  }
  _$AI(t, e = this) {
    if ((t = L(this, t, e, 0) ?? d) === O)
      return;
    const r = this._$AH, o = t === d && r !== d || t.capture !== r.capture || t.once !== r.once || t.passive !== r.passive, s = t !== d && (r === d || o);
    o && this.element.removeEventListener(this.name, this, r), s && this.element.addEventListener(this.name, this, t), this._$AH = t;
  }
  handleEvent(t) {
    var e;
    typeof this._$AH == "function" ? this._$AH.call(((e = this.options) == null ? void 0 : e.host) ?? this.element, t) : this._$AH.handleEvent(t);
  }
}
class re {
  constructor(t, e, r) {
    this.element = t, this.type = 6, this._$AN = void 0, this._$AM = e, this.options = r;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AI(t) {
    L(this, t);
  }
}
const lt = F.litHtmlPolyfillSupport;
lt == null || lt(K, Z), (F.litHtmlVersions ?? (F.litHtmlVersions = [])).push("3.1.2");
const ie = (i, t, e) => {
  const r = (e == null ? void 0 : e.renderBefore) ?? t;
  let o = r._$litPart$;
  if (o === void 0) {
    const s = (e == null ? void 0 : e.renderBefore) ?? null;
    r._$litPart$ = o = new Z(t.insertBefore(q(), s), s, void 0, e ?? {});
  }
  return o._$AI(i), o;
};
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
let m = class extends H {
  constructor() {
    super(...arguments), this.renderOptions = { host: this }, this._$Do = void 0;
  }
  createRenderRoot() {
    var e;
    const t = super.createRenderRoot();
    return (e = this.renderOptions).renderBefore ?? (e.renderBefore = t.firstChild), t;
  }
  update(t) {
    const e = this.render();
    this.hasUpdated || (this.renderOptions.isConnected = this.isConnected), super.update(t), this._$Do = ie(e, this.renderRoot, this.renderOptions);
  }
  connectedCallback() {
    var t;
    super.connectedCallback(), (t = this._$Do) == null || t.setConnected(!0);
  }
  disconnectedCallback() {
    var t;
    super.disconnectedCallback(), (t = this._$Do) == null || t.setConnected(!1);
  }
  render() {
    return O;
  }
};
var Pt;
m._$litElement$ = !0, m.finalized = !0, (Pt = globalThis.litElementHydrateSupport) == null || Pt.call(globalThis, { LitElement: m });
const ct = globalThis.litElementPolyfillSupport;
ct == null || ct({ LitElement: m });
(globalThis.litElementVersions ?? (globalThis.litElementVersions = [])).push("4.0.4");
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const T = (i) => (t, e) => {
  e !== void 0 ? e.addInitializer(() => {
    customElements.define(i, t);
  }) : customElements.define(i, t);
};
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const oe = { attribute: !0, type: String, converter: rt, reflect: !1, hasChanged: pt }, se = (i = oe, t, e) => {
  const { kind: r, metadata: o } = e;
  let s = globalThis.litPropertyMetadata.get(o);
  if (s === void 0 && globalThis.litPropertyMetadata.set(o, s = /* @__PURE__ */ new Map()), s.set(e.name, i), r === "accessor") {
    const { name: n } = e;
    return { set(c) {
      const l = t.get.call(this);
      t.set.call(this, c), this.requestUpdate(n, l, i);
    }, init(c) {
      return c !== void 0 && this.P(n, void 0, i), c;
    } };
  }
  if (r === "setter") {
    const { name: n } = e;
    return function(c) {
      const l = this[n];
      t.call(this, c), this.requestUpdate(n, l, i);
    };
  }
  throw Error("Unsupported decorator location: " + r);
};
function a(i) {
  return (t, e) => typeof e == "object" ? se(i, t, e) : ((r, o, s) => {
    const n = o.hasOwnProperty(s);
    return o.constructor.createProperty(s, n ? { ...r, wrapped: !0 } : r), n ? Object.getOwnPropertyDescriptor(o, s) : void 0;
  })(i, t, e);
}
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function Q(i) {
  return a({ ...i, state: !0, attribute: !1 });
}
const ne = ":host([disabled]){cursor:not-allowed!important;pointer-events:none!important}:host([disabled]) span[disabled],:host([disabled]) span:disabled,:host([disabled]) span.disabled{opacity:.65!important;pointer-events:none!important;cursor:not-allowed!important}:host{width:var(--pf-width, inherit);display:var(--pf-display, inline-block)}:host span{display:var(--pf-display, inline-block);width:var(--pf-width, auto);font-weight:700;text-align:center;white-space:nowrap;vertical-align:baseline;border-radius:.25rem;transition:color .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host([variant=primary]) span{color:#fff;border-color:#007bff;background-color:#007bff}:host([variant=primary]) span .loader{border-color:#fff}:host([variant=secondary]) span{color:#fff;background-color:#6d767e;border-color:#6c757d}:host([variant=secondary]) span .loader{border-color:#fff}:host([variant=success]) span{color:#fff;background-color:#28a745;border-color:#28a745}:host([variant=success]) span .loader{border-color:#fff}:host([variant=danger]) span{color:#fff;background-color:#dc3545;border-color:#dc3545}:host([variant=danger]) span .loader{border-color:#fff}:host([variant=warning]) span{color:#212529;background-color:#ffc107;border-color:#ffc107}:host([variant=warning]) span .loader{border-color:#212529}:host([variant=info]) span{color:#fff;background-color:#17a2b8;border-color:#17a2b8}:host([variant=info]) span .loader{border-color:#fff}:host([variant=light]) span{color:#212529;background-color:#f8f9fa;border-color:#f8f9fa}:host([variant=light]) span .loader{border-color:#212529}:host([variant=dark]) span{color:#fff;background-color:#343a40;border-color:#343a40}:host([variant=dark]) span .loader{border-color:#fff}:host([pill]) span{padding-right:.6em;padding-left:.6em;border-radius:10rem}:host([size=large]) span{padding:.5rem;font-size:.8rem}:host([size=default]) span{padding:.375rem .4rem;font-size:.7rem}:host([size=small]) span{padding:.25rem .3rem;font-size:.6rem}";
var ae = Object.defineProperty, le = Object.getOwnPropertyDescriptor, I = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? le(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && ae(t, e, o), o;
};
let R = class extends m {
  constructor() {
    super(), this.variant = "primary", this.pill = !1, this.class = "", this.id = "", this.size = "default";
  }
  static get styles() {
    return [N(ne)];
  }
  render() {
    return y`<span><slot></slot></span>`;
  }
};
I([
  a({ type: String, attribute: !0, reflect: !0 })
], R.prototype, "variant", 2);
I([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], R.prototype, "pill", 2);
I([
  a({ type: String, attribute: !0, reflect: !0 })
], R.prototype, "class", 2);
I([
  a({ type: String, attribute: !0, reflect: !0 })
], R.prototype, "id", 2);
I([
  a({ type: String, attribute: !0, reflect: !0 })
], R.prototype, "size", 2);
R = I([
  T("pf-badge")
], R);
/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function ce(i, t, e) {
  return i ? t(i) : e == null ? void 0 : e(i);
}
const he = ":host([disabled]){cursor:not-allowed!important;pointer-events:none!important}:host([disabled]) button[disabled],:host([disabled]) button:disabled,:host([disabled]) button.disabled{opacity:.65!important;pointer-events:none!important;cursor:not-allowed!important}:host([loading]){cursor:not-allowed!important;pointer-events:none!important}:host([loading]) button{opacity:.65!important;pointer-events:none!important;cursor:not-allowed!important}:host{width:var(--pf-width, auto);display:var(--pf-display, inline-block)}:host button{font-weight:400;text-align:center;vertical-align:middle;-webkit-user-select:none;user-select:none;border:1px solid transparent;display:var(--pf-display, inline-block);width:var(--pf-width, auto);line-height:1.5;transition:color .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out;cursor:pointer}:host([variant=primary]) button{color:#fff;border-color:#007bff;background-color:#007bff}:host([variant=primary]) button pf-spinner{--pf-color: #fff}:host([variant=primary][outline]) button{background-color:transparent;color:#007bff}:host([variant=primary][outline]) button pf-spinner{--pf-color: #007bff}:host([variant=primary][outline]) button:hover{background-color:transparent;color:#007bff}:host([variant=primary][outline]) button:hover pf-spinner{--pf-color: #007bff}:host([variant=secondary]) button{color:#fff;background-color:#6d767e;border-color:#6c757d}:host([variant=secondary]) button pf-spinner{--pf-color: #fff}:host([variant=secondary][outline]) button{background-color:transparent;color:#6c757d}:host([variant=secondary][outline]) button pf-spinner{--pf-color: #6c757d}:host([variant=secondary][outline]) button:hover{color:#fff;background-color:#6d767e;border-color:#6c757d}:host([variant=secondary][outline]) button:hover pf-spinner{--pf-color: #fff}:host([variant=success]) button{color:#fff;background-color:#28a745;border-color:#28a745}:host([variant=success]) button pf-spinner{--pf-color: #fff}:host([variant=success][outline]) button{color:#28a745;background-color:transparent}:host([variant=success][outline]) button pf-spinner{--pf-color: #28a745}:host([variant=success][outline]) button:hover{color:#fff;background-color:#28a745;border-color:#28a745}:host([variant=success][outline]) button:hover pf-spinner{--pf-color: #fff}:host([variant=danger]) button{color:#fff;background-color:#dc3545;border-color:#dc3545}:host([variant=danger]) button pf-spinner{--pf-color: #fff}:host([variant=danger][outline]) button{color:#dc3545;background-color:transparent}:host([variant=danger][outline]) button pf-spinner{--pf-color: #dc3545}:host([variant=danger][outline]) button:hover{color:#fff;background-color:#dc3545;border-color:#dc3545}:host([variant=danger][outline]) button:hover pf-spinner{--pf-color: #fff}:host([variant=warning]) button{color:#212529;background-color:#ffc107;border-color:#ffc107}:host([variant=warning]) button pf-spinner{--pf-color: #212529}:host([variant=warning][outline]) button{color:#ffc107;background-color:transparent}:host([variant=warning][outline]) button pf-spinner{--pf-color: #ffc107}:host([variant=warning][outline]) button:hover{color:#212529;background-color:#ffc107;border-color:#ffc107}:host([variant=warning][outline]) button:hover pf-spinner{--pf-color: #212529}:host([variant=info]) button{color:#fff;background-color:#17a2b8;border-color:#17a2b8}:host([variant=info]) button pf-spinner{--pf-color: #fff}:host([variant=info][outline]) button{color:#17a2b8;background-color:transparent}:host([variant=info][outline]) button pf-spinner{--pf-color: #17a2b8}:host([variant=info][outline]) button:hover{color:#fff;background-color:#17a2b8;border-color:#17a2b8}:host([variant=info][outline]) button:hover pf-spinner{--pf-color: #fff}:host([variant=light]) button{color:#212529;background-color:#f8f9fa;border-color:#f8f9fa}:host([variant=light]) button pf-spinner{--pf-color: #212529}:host([variant=light][outline]) button{color:#f8f9fa;background-color:transparent}:host([variant=light][outline]) button pf-spinner{--pf-color: #f8f9fa}:host([variant=light][outline]) button:hover{color:#212529;background-color:#f8f9fa;border-color:#f8f9fa}:host([variant=light][outline]) button:hover pf-spinner{--pf-color: #212529}:host([variant=dark]) button{color:#fff;background-color:#343a40;border-color:#343a40}:host([variant=dark]) button pf-spinner{--pf-color: #fff}:host([variant=dark][outline]) button{color:#343a40;background-color:transparent}:host([variant=dark][outline]) button pf-spinner{--pf-color: #343a40}:host([variant=dark][outline]) button:hover{color:#fff;background-color:#343a40;border-color:#343a40}:host([variant=dark][outline]) button:hover pf-spinner{--pf-color: #fff}:host([variant=link]) button{font-weight:400;color:#007bff;text-decoration:none}:host([variant=link]) button pf-spinner{--pf-color: #007bff}:host([variant=link][outline]) button{color:#007bff;background-color:transparent}:host([variant=link][outline]) button pf-spinner{--pf-color: #007bff}:host([variant=link][outline]) button:hover{font-weight:400;color:#007bff;text-decoration:none}:host([variant=link][outline]) button:hover pf-spinner{--pf-color: #007bff}:host([size=large]) button{padding:.5rem 1rem;font-size:1.25rem;border-radius:.3rem;min-width:var(--pf-width, 3rem)}:host([size=large]) button pf-spinner{--pf-font-size: .2rem;--pf-size: 1rem}:host([size=default]) button{padding:.375rem .75rem;font-size:1rem;border-radius:.25rem;min-width:var(--pf-width, 2.5rem)}:host([size=default]) button pf-spinner{--pf-font-size: .15rem;--pf-size: .8rem}:host([size=small]) button{padding:.25rem .5rem;font-size:.875rem;border-radius:.2rem;min-width:var(--pf-width, 2rem)}:host([size=small]) button pf-spinner{--pf-font-size: .1rem;--pf-size: .6rem}:host([block]){display:block;width:100%}:host([block]) button{display:block;width:100%}pf-spinner{--pf-display: inline-block}";
var de = Object.defineProperty, pe = Object.getOwnPropertyDescriptor, C = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? pe(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && de(t, e, o), o;
};
let x = class extends m {
  constructor() {
    super(), this.disabled = !1, this.loading = !1, this.block = !1, this.outline = !1, this.size = "default", this.variant = "primary", this.class = "", this.id = "";
  }
  static get styles() {
    return [N(he)];
  }
  onClickHandler(i) {
    i.preventDefault(), i.stopImmediatePropagation(), i.stopPropagation(), this.disabled || this.loading || this.dispatchEvent(new MouseEvent("click", { bubbles: !0 }));
  }
  render() {
    return y`<button ?disabled=${this.disabled || this.loading} @click=${this.onClickHandler}>
      ${ce(
      this.loading,
      () => y`<pf-spinner style="position: relative; top: 0.15rem; left: -0.1rem;"></pf-spinner>`,
      () => y`<slot></slot>`
    )}
    </button>`;
  }
};
C([
  a({
    type: Boolean,
    attribute: !0,
    reflect: !0
  })
], x.prototype, "disabled", 2);
C([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], x.prototype, "loading", 2);
C([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], x.prototype, "block", 2);
C([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], x.prototype, "outline", 2);
C([
  a({ type: String, attribute: !0, reflect: !0 })
], x.prototype, "size", 2);
C([
  a({ type: String, attribute: !0, reflect: !0 })
], x.prototype, "variant", 2);
C([
  a({ type: String, attribute: !0, reflect: !0 })
], x.prototype, "class", 2);
C([
  a({ type: String, attribute: !0, reflect: !0 })
], x.prototype, "id", 2);
x = C([
  T("pf-button")
], x);
const ue = ":host([disabled]){cursor:not-allowed;pointer-events:none}:host{width:var(--pf-width, inherit);display:var(--pf-display, inline-block)}:host input[type=checkbox]{padding:0;margin:0;overflow:visible;cursor:pointer;width:var(--pf-width, inherit);display:var(--pf-display, inline-block)}";
var fe = Object.defineProperty, ge = Object.getOwnPropertyDescriptor, G = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? ge(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && fe(t, e, o), o;
};
let D = class extends m {
  constructor() {
    super(...arguments), this.disabled = !1, this.checked = !1, this.class = "", this.id = "";
  }
  static get styles() {
    return [N(ue)];
  }
  handleOnChange(i) {
    this.checked = i.target.checked, i.preventDefault(), i.stopPropagation(), this.disabled || this.dispatchEvent(new Event("change", { bubbles: !0 }));
  }
  render() {
    return y`<input
      type="checkbox"
      ?checked=${this.checked}
      ?disabled=${this.disabled}
      @change=${this.handleOnChange}
    />`;
  }
};
G([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], D.prototype, "disabled", 2);
G([
  a({
    type: Boolean,
    attribute: !0,
    reflect: !0
  })
], D.prototype, "checked", 2);
G([
  a({ type: String, attribute: !0, reflect: !0 })
], D.prototype, "class", 2);
G([
  a({ type: String, attribute: !0, reflect: !0 })
], D.prototype, "id", 2);
D = G([
  T("pf-checkbox")
], D);
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const ut = { ATTRIBUTE: 1, CHILD: 2, PROPERTY: 3, BOOLEAN_ATTRIBUTE: 4, EVENT: 5, ELEMENT: 6 }, ft = (i) => (...t) => ({ _$litDirective$: i, values: t });
let gt = class {
  constructor(t) {
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AT(t, e, r) {
    this._$Ct = t, this._$AM = e, this._$Ci = r;
  }
  _$AS(t, e) {
    return this.update(t, e);
  }
  update(t, e) {
    return this.render(...e);
  }
};
/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const St = ft(class extends gt {
  constructor(i) {
    var t;
    if (super(i), i.type !== ut.ATTRIBUTE || i.name !== "class" || ((t = i.strings) == null ? void 0 : t.length) > 2)
      throw Error("`classMap()` can only be used in the `class` attribute and must be the only part in the attribute.");
  }
  render(i) {
    return " " + Object.keys(i).filter((t) => i[t]).join(" ") + " ";
  }
  update(i, [t]) {
    var r, o;
    if (this.st === void 0) {
      this.st = /* @__PURE__ */ new Set(), i.strings !== void 0 && (this.nt = new Set(i.strings.join(" ").split(/\s/).filter((s) => s !== "")));
      for (const s in t)
        t[s] && !((r = this.nt) != null && r.has(s)) && this.st.add(s);
      return this.render(t);
    }
    const e = i.element.classList;
    for (const s of this.st)
      s in t || (e.remove(s), this.st.delete(s));
    for (const s in t) {
      const n = !!t[s];
      n === this.st.has(s) || (o = this.nt) != null && o.has(s) || (n ? (e.add(s), this.st.add(s)) : (e.remove(s), this.st.delete(s)));
    }
    return O;
  }
});
/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const be = (i) => i.strings === void 0;
/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const V = (i, t) => {
  var r;
  const e = i._$AN;
  if (e === void 0)
    return !1;
  for (const o of e)
    (r = o._$AO) == null || r.call(o, t, !1), V(o, t);
  return !0;
}, ot = (i) => {
  let t, e;
  do {
    if ((t = i._$AM) === void 0)
      break;
    e = t._$AN, e.delete(i), i = t;
  } while ((e == null ? void 0 : e.size) === 0);
}, Rt = (i) => {
  for (let t; t = i._$AM; i = t) {
    let e = t._$AN;
    if (e === void 0)
      t._$AN = e = /* @__PURE__ */ new Set();
    else if (e.has(i))
      break;
    e.add(i), ye(t);
  }
};
function me(i) {
  this._$AN !== void 0 ? (ot(this), this._$AM = i, Rt(this)) : this._$AM = i;
}
function ve(i, t = !1, e = 0) {
  const r = this._$AH, o = this._$AN;
  if (o !== void 0 && o.size !== 0)
    if (t)
      if (Array.isArray(r))
        for (let s = e; s < r.length; s++)
          V(r[s], !1), ot(r[s]);
      else
        r != null && (V(r, !1), ot(r));
    else
      V(this, i);
}
const ye = (i) => {
  i.type == ut.CHILD && (i._$AP ?? (i._$AP = ve), i._$AQ ?? (i._$AQ = me));
};
class $e extends gt {
  constructor() {
    super(...arguments), this._$AN = void 0;
  }
  _$AT(t, e, r) {
    super._$AT(t, e, r), Rt(this), this.isConnected = t._$AU;
  }
  _$AO(t, e = !0) {
    var r, o;
    t !== this.isConnected && (this.isConnected = t, t ? (r = this.reconnected) == null || r.call(this) : (o = this.disconnected) == null || o.call(this)), e && (V(this, t), ot(this));
  }
  setValue(t) {
    if (be(this._$Ct))
      this._$Ct._$AI(t, this);
    else {
      const e = [...this._$Ct._$AH];
      e[this._$Ci] = t, this._$Ct._$AI(e, this, 0);
    }
  }
  disconnected() {
  }
  reconnected() {
  }
}
/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const Nt = () => new we();
class we {
}
const ht = /* @__PURE__ */ new WeakMap(), Ct = ft(class extends $e {
  render(i) {
    return d;
  }
  update(i, [t]) {
    var r;
    const e = t !== this.Y;
    return e && this.Y !== void 0 && this.rt(void 0), (e || this.lt !== this.ct) && (this.Y = t, this.ht = (r = i.options) == null ? void 0 : r.host, this.rt(this.ct = i.element)), d;
  }
  rt(i) {
    if (typeof this.Y == "function") {
      const t = this.ht ?? globalThis;
      let e = ht.get(t);
      e === void 0 && (e = /* @__PURE__ */ new WeakMap(), ht.set(t, e)), e.get(this.Y) !== void 0 && this.Y.call(this.ht, void 0), e.set(this.Y, i), i !== void 0 && this.Y.call(this.ht, i);
    } else
      this.Y.value = i;
  }
  get lt() {
    var i, t;
    return typeof this.Y == "function" ? (i = ht.get(this.ht ?? globalThis)) == null ? void 0 : i.get(this.Y) : (t = this.Y) == null ? void 0 : t.value;
  }
  disconnected() {
    this.lt === this.ct && this.rt(void 0);
  }
  reconnected() {
    this.rt(this.ct);
  }
});
/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const Ht = "important", _e = " !" + Ht, xe = ft(class extends gt {
  constructor(i) {
    var t;
    if (super(i), i.type !== ut.ATTRIBUTE || i.name !== "style" || ((t = i.strings) == null ? void 0 : t.length) > 2)
      throw Error("The `styleMap` directive must be used in the `style` attribute and must be the only part in the attribute.");
  }
  render(i) {
    return Object.keys(i).reduce((t, e) => {
      const r = i[e];
      return r == null ? t : t + `${e = e.includes("-") ? e : e.replace(/(?:^(webkit|moz|ms|o)|)(?=[A-Z])/g, "-$&").toLowerCase()}:${r};`;
    }, "");
  }
  update(i, [t]) {
    const { style: e } = i.element;
    if (this.ft === void 0)
      return this.ft = new Set(Object.keys(t)), this.render(t);
    for (const r of this.ft)
      t[r] == null && (this.ft.delete(r), r.includes("-") ? e.removeProperty(r) : e[r] = null);
    for (const r in t) {
      const o = t[r];
      if (o != null) {
        this.ft.add(r);
        const s = typeof o == "string" && o.endsWith(_e);
        r.includes("-") || s ? e.setProperty(r, s ? o.slice(0, -11) : o, s ? Ht : "") : e[r] = o;
      }
    }
    return O;
  }
}), Ae = ':host{display:inline-block;position:relative;width:var(--pf-width, auto);height:var(--pf-height, auto);border-radius:var(--pf-dropdown-border-radius, .25rem);border:var(--pf-dropdown-border, inherit)}:host slot[name=head]{display:flex;justify-content:space-between;align-items:center;cursor:pointer;width:var(--pf-width, auto);height:var(--pf-height, auto)}:host slot[name=head].show-arrow:after{display:inline-block;margin-left:.255em;vertical-align:.255em;position:absolute;right:.6rem;color:var(--pf-color, #fff);content:"";border-top:.3em solid;border-right:.3em solid transparent;border-bottom:0;border-left:.3em solid transparent}:host slot[name=head].up:after{transform:rotate(-180deg);-webkit-transform:rotate(-180deg);transition:all .1s ease-in-out}:host slot[name=head].down:after{transform:rotate(0);-webkit-transform:rotate(0);transition:all .1s ease-in-out}:host slot[name=body]{position:absolute;top:0;left:0;z-index:1000;display:none;float:left;font-size:1rem;color:#212529;text-align:left;list-style:none;background-color:#fff;background-clip:padding-box;border:1px solid rgba(0,0,0,.15);border-radius:.25rem;transform:translate3d(0,38px,0);will-change:transform;height:var(--pf-dropdown-menu-height, inherit);min-width:var(--pf-dropdown-menu-min-width, 10rem);padding:var(--pf-dropdown-menu-padding-y, .5rem) var(--pf-dropdown-menu-padding-x, 0);margin:var(--pf-dropdown-menu-margin-y, .125rem) var(--pf-dropdown-menu-margin-x, 0);margin-top:var(--pf-dropdown-menu-margin-top, inherit);margin-bottom:var(--pf-dropdown-menu-margin-bottom, inherit);margin-right:var(--pf-dropdown-menu-margin-right, inherit);margin-left:var(--pf-dropdown-menu-margin-left, inherit);padding-top:var(--pf-dropdown-menu-padding-top, inherit);padding-bottom:var(--pf-dropdown-menu-padding-bottom, inherit);padding-right:var(--pf-dropdown-menu-padding-right, inherit);padding-left:var(--pf-dropdown-menu-padding-left, inherit)}:host slot[name=body].show{transition:all .4s ease-in-out;display:block}';
var ke = Object.defineProperty, Se = Object.getOwnPropertyDescriptor, A = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? Se(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && ke(t, e, o), o;
};
let $ = class extends m {
  constructor() {
    super(), this._dropdownButtonRef = Nt(), this._dropdownMenuRef = Nt(), this._windowWidth = 0, this._fixedStyles = { left: "inherit", right: "0px" }, this.disabled = !1, this.size = "default", this.class = "", this.id = "", this.isOpen = !1, this.hideArrow = !1, this.openOnButtonClick = !0, window.addEventListener("click", (i) => {
      const t = i.target;
      this !== t && !this.contains(t) && this.closeDropdown();
    }), window.addEventListener("resize", () => {
      this.calculateFixedStyles();
    });
  }
  static get styles() {
    return [N(Ae)];
  }
  handleOnButtonClick() {
    this.openOnButtonClick && this.toggleDropdown();
  }
  openDropdown() {
    this.isOpen = !0, this.calculateFixedStyles();
  }
  closeDropdown() {
    this.isOpen = !1;
  }
  toggleDropdown() {
    this.isOpen ? this.closeDropdown() : this.openDropdown();
  }
  calculateFixedStyles() {
    var o, s, n;
    this._windowWidth = document.body.offsetWidth;
    const i = (o = this._dropdownButtonRef.value) == null ? void 0 : o.offsetWidth, t = (s = this._dropdownMenuRef.value) == null ? void 0 : s.offsetWidth, e = (n = this._dropdownButtonRef.value) == null ? void 0 : n.getBoundingClientRect().left;
    if (!e || !i || !t) {
      this._fixedStyles = { left: "inherit", right: "0px" };
      return;
    }
    const r = e + i + 5;
    r < t ? this._windowWidth < t ? this._fixedStyles = {
      left: "inherit",
      right: `${r + 5 - this._windowWidth}px`
    } : this._fixedStyles = {
      left: "inherit",
      right: `${t - 5 - this._windowWidth}px`
    } : this._fixedStyles = { left: "inherit", right: "0px" };
  }
  render() {
    return y` <slot
        ${Ct(this._dropdownButtonRef)}
        @click=${this.handleOnButtonClick}
        name="head"
        class=${St({
      "show-arrow": !this.hideArrow,
      down: !this.isOpen,
      up: this.isOpen
    })}
      ></slot>
      <slot
        ${Ct(this._dropdownMenuRef)}
        name="body"
        class=${St({ show: this.isOpen })}
        style=${xe({
      ...this._fixedStyles
    })}
      ></slot>`;
  }
};
A([
  Q()
], $.prototype, "_windowWidth", 2);
A([
  Q()
], $.prototype, "_fixedStyles", 2);
A([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], $.prototype, "disabled", 2);
A([
  a({ type: String, attribute: !0, reflect: !0 })
], $.prototype, "size", 2);
A([
  a({ type: String, attribute: !0, reflect: !0 })
], $.prototype, "class", 2);
A([
  a({ type: String, attribute: !0, reflect: !0 })
], $.prototype, "id", 2);
A([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], $.prototype, "isOpen", 2);
A([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], $.prototype, "hideArrow", 2);
A([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], $.prototype, "openOnButtonClick", 2);
$ = A([
  T("pf-dropdown")
], $);
const Et = (i) => {
  const t = new Blob([i], { type: "image/svg+xml" });
  return URL.createObjectURL(t);
}, _ = (i) => {
  if (!i)
    return null;
  try {
    return new URL(i);
  } catch {
    return null;
  }
}, Ne = `
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" style="margin: auto; background: none; display: block; shape-rendering: auto;" width="24px" height="24px" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid">
  <g transform="rotate(0 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.9166666666666666s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(30 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.8333333333333334s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(60 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.75s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(90 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.6666666666666666s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(120 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.5833333333333334s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(150 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.5s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(180 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.4166666666666667s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(210 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.3333333333333333s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(240 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.25s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(270 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.16666666666666666s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(300 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="-0.08333333333333333s" repeatCount="indefinite"></animate>
    </rect>
  </g>
  <g transform="rotate(330 50 50)">
    <rect x="47" y="24" rx="3" ry="6" width="6" height="12" fill="rgba(NaN, NaN, NaN, 0)">
      <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1s" begin="0s" repeatCount="indefinite"></animate>
    </rect>
  </g>
</svg>
`, Ce = `
<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 490.667 490.667" style="enable-background:new 0 0 490.667 490.667;" xml:space="preserve">
	<g>
		<g>
			<g>
				<path d="M309.333,128h-12.48c-4.416-12.416-16.277-21.333-30.187-21.333H224c-14.528,0-26.816,9.728-30.699,22.997
				c-1.813,1.152-3.285,2.859-4.139,4.928c-1.664,3.989-0.747,8.576,2.304,11.627l29.035,29.035
				c7.808-2.773,16.085-4.565,24.832-4.565c41.173,0,74.667,33.493,74.667,74.667c0,8.747-1.792,17.024-4.565,24.832l46.613,46.613
				c2.027,2.027,4.736,3.115,7.552,3.115c0.789,0,1.579-0.085,2.368-0.277c3.563-0.811,6.485-3.392,7.701-6.848
				c2.901-8.235,4.373-16.576,4.373-24.789v-85.333C384,161.493,350.507,128,309.333,128z" />
				<path d="M245.333,0C110.059,0,0,110.059,0,245.333s110.059,245.333,245.333,245.333s245.333-110.059,245.333-245.333
				S380.608,0,245.333,0z M245.333,469.333c-123.52,0-224-100.48-224-224c0-57.92,22.293-110.613,58.496-150.421l52.267,52.267
				c-15.808,14.08-25.429,34.176-25.429,55.488V288c0,41.173,33.493,74.667,74.667,74.667h128c10.773,0,21.291-2.773,31.019-7.232
				l55.403,55.403C355.947,447.04,303.253,469.333,245.333,469.333z M170.667,245.333c0-16.725,5.931-31.851,15.296-44.288
				l103.68,103.68C277.205,314.091,262.059,320,245.333,320C204.16,320,170.667,286.507,170.667,245.333z M410.837,395.755
				L94.933,79.851c39.808-36.203,92.501-58.496,150.421-58.496c123.52,0,224,100.48,224,224
				C469.333,303.253,447.04,355.947,410.837,395.755z" />
			</g>
		</g>
	</g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
	<g></g>
</svg>`, Ee = ":host([disabled]){cursor:not-allowed;pointer-events:none;opacity:.8}:host([rounded]){border-radius:100%}:host([rounded]) img{border-radius:100%}:host{box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;display:inline-block;margin:0;padding:0;background-color:transparent}:host img{margin:0;padding:0;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;object-fit:cover;box-shadow:var(--pf-box-shadow, inherit);padding:var(--pf-padding, inherit);margin:var(--pf-margin, inherit);border:var(--pf-border, inherit)}";
var Pe = Object.defineProperty, ze = Object.getOwnPropertyDescriptor, g = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? ze(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && Pe(t, e, o), o;
};
let f = class extends m {
  constructor() {
    super(...arguments), this._hasSrcfailed = !1, this._hasFallbackSrcfailed = !1, this._imageLoading = !1, this.disabled = !1, this.src = null, this.fallbackSrc = null, this.alt = null, this.loading = !1, this.rounded = !1, this.width = 0, this.height = 0, this.class = "", this.id = "";
  }
  static get styles() {
    return [N(Ee)];
  }
  getImageUrl() {
    return this._imageLoading || this.loading ? Et(Ne) : this.src && !this._hasSrcfailed ? this.src : this.fallbackSrc && !this._hasFallbackSrcfailed ? this.fallbackSrc : Et(Ce);
  }
  onImageLoad(i) {
    var o, s, n;
    const t = (o = _(i.target.src)) == null ? void 0 : o.pathname, e = _(this.src) ? (s = _(this.src)) == null ? void 0 : s.pathname : this.src, r = _(this.fallbackSrc) ? (n = _(this.fallbackSrc)) == null ? void 0 : n.pathname : this.fallbackSrc;
    !this._hasSrcfailed && (!this.src || t === e) && (this._hasSrcfailed = !1), !this._hasFallbackSrcfailed && (!this.fallbackSrc || t === r) && (this._hasFallbackSrcfailed = !1), this._imageLoading = !1;
  }
  onImageError(i) {
    var o, s, n;
    const t = (o = _(i.target.src)) == null ? void 0 : o.pathname, e = _(this.src) ? (s = _(this.src)) == null ? void 0 : s.pathname : this.src, r = _(this.fallbackSrc) ? (n = _(this.fallbackSrc)) == null ? void 0 : n.pathname : this.fallbackSrc;
    !this._hasSrcfailed && (!this.src || t === e) && (this._hasSrcfailed = !0), !this._hasFallbackSrcfailed && (!this.fallbackSrc || t === r) && (this._hasFallbackSrcfailed = !0), this._imageLoading = !1;
  }
  render() {
    return y`<img
      src=${this.getImageUrl()}
      alt=${this.alt || ""}
      width=${this.width}
      height=${this.height}
      @load=${this.onImageLoad}
      @error=${this.onImageError}
    />`;
  }
};
g([
  Q()
], f.prototype, "_hasSrcfailed", 2);
g([
  Q()
], f.prototype, "_hasFallbackSrcfailed", 2);
g([
  Q()
], f.prototype, "_imageLoading", 2);
g([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], f.prototype, "disabled", 2);
g([
  a({ type: String, attribute: !0, reflect: !0 })
], f.prototype, "src", 2);
g([
  a({ type: String, attribute: !0, reflect: !0 })
], f.prototype, "fallbackSrc", 2);
g([
  a({ type: String, attribute: !0, reflect: !0 })
], f.prototype, "alt", 2);
g([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], f.prototype, "loading", 2);
g([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], f.prototype, "rounded", 2);
g([
  a({ type: Number, attribute: !0, reflect: !0 })
], f.prototype, "width", 2);
g([
  a({ type: Number, attribute: !0, reflect: !0 })
], f.prototype, "height", 2);
g([
  a({ type: String, attribute: !0, reflect: !0 })
], f.prototype, "class", 2);
g([
  a({ type: String, attribute: !0, reflect: !0 })
], f.prototype, "id", 2);
f = g([
  T("pf-image")
], f);
const Oe = `:host([disabled]){cursor:not-allowed!important;pointer-events:none!important}:host([disabled]) input[disabled],:host([disabled]) input:disabled,:host([disabled]) input.disabled{background-color:#e9ecef;opacity:1;pointer-events:none;cursor:not-allowed}:host{width:var(--pf-width, auto);display:var(--pf-display, inline-block);box-sizing:border-box}:host input{box-sizing:border-box;font-weight:400;color:#495057;background-color:#fff;background-clip:padding-box;border:1px solid #ced4da;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;margin:0}:host([size=large]) input{height:calc(1.5em + 1rem + 2px);padding:.5rem 1rem;font-size:1.25rem;line-height:1.5;border-radius:.3rem}:host([size=default]) input{height:calc(1.5em + .75rem + 2px);padding:.375rem .75rem;font-size:1rem;line-height:1.5;border-radius:.25rem}:host([size=small]) input{height:calc(1.5em + .5rem + 2px);padding:.25rem .5rem;font-size:.875rem;line-height:1.5;border-radius:.2rem}:host([block]){display:block;width:100%}:host([block]) input{display:block;width:100%}:host([valid]) input{border-color:#28a745;padding-right:calc(1.5em + .75rem)!important;background-image:url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath fill='%2328a745' d='M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z'/%3e%3c/svg%3e");background-repeat:no-repeat;background-position:right calc(.375em + .1875rem) center;background-size:calc(.75em + .375rem) calc(.75em + .375rem)}:host([invalid]) input{border-color:#dc3545;padding-right:calc(1.5em + .75rem)!important;background-image:url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='%23dc3545' viewBox='0 0 12 12'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e");background-repeat:no-repeat;background-position:right calc(.375em + .1875rem) center;background-size:calc(.75em + .375rem) calc(.75em + .375rem)}`;
var Te = Object.defineProperty, Be = Object.getOwnPropertyDescriptor, v = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? Be(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && Te(t, e, o), o;
};
let b = class extends m {
  constructor() {
    super(...arguments), this.disabled = !1, this.block = !1, this.size = "default", this.class = "", this.id = "", this.placeholder = "", this.value = "", this.name = "", this.type = "text", this.valid = !1, this.invalid = !1;
  }
  static get styles() {
    return [N(Oe)];
  }
  onChangeHandler(i) {
    var t;
    this.value = (t = i == null ? void 0 : i.target) == null ? void 0 : t.value, i.preventDefault(), i.stopPropagation(), this.dispatchEvent(
      new CustomEvent("change", {
        bubbles: !0,
        detail: this.value
      })
    );
  }
  render() {
    return y`<input
      type=${this.type}
      name=${this.name}
      placeholder=${this.placeholder}
      value=${this.value}
      ?disabled=${this.disabled}
      @change=${this.onChangeHandler}
    />`;
  }
};
v([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], b.prototype, "disabled", 2);
v([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], b.prototype, "block", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "size", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "class", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "id", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "placeholder", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "value", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "name", 2);
v([
  a({ type: String, attribute: !0, reflect: !0 })
], b.prototype, "type", 2);
v([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], b.prototype, "valid", 2);
v([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], b.prototype, "invalid", 2);
b = v([
  T("pf-input")
], b);
/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function* Ue(i, t) {
  if (i !== void 0) {
    let e = 0;
    for (const r of i)
      yield t(r, e++);
  }
}
const Me = `:host{width:var(--pf-width, inherit);display:var(--pf-display, inline-block)}:host select{background:#fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") right .75rem center/8px 10px no-repeat;display:inline-block;width:100%;height:calc(1.5em + .75rem + 2px);padding:.375rem 1.75rem .375rem .75rem;font-size:1rem;font-weight:400;line-height:1.5;color:#495057;vertical-align:middle;-webkit-appearance:none;-moz-appearance:none;appearance:none;transition:background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out}select[disabled],select:disabled{background-color:#e9ecef;opacity:1;pointer-events:none;cursor:not-allowed}:host([size=default]) select{height:calc(1.5em + .75rem + 2px);padding:.375rem .75rem;font-size:1rem;line-height:1.5;border-radius:.25rem}:host([size=large]) select{height:calc(1.5em + 1rem + 2px);padding:.5rem 1rem;font-size:1.25rem;line-height:1.5;border-radius:.3rem}:host([size=small]) select{height:calc(1.5em + .5rem + 2px);padding:.25rem .5rem;font-size:.875rem;line-height:1.5;border-radius:.2rem}:host([block]){display:block;width:100%}:host([block]) input{display:block;width:100%}:host([valid]) select{border-color:#28a745;padding-right:calc(.75em + 2.3125rem)!important;background:url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") right .75rem center/8px 10px no-repeat,#fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath fill='%2328a745' d='M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z'/%3e%3c/svg%3e") center right 1.75rem/ calc(.75em + .375rem) calc(.75em + .375rem) no-repeat}:host([invalid]) select{border-color:#dc3545;padding-right:calc(.75em + 2.3125rem)!important;background:url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") right .75rem center/8px 10px no-repeat,#fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='%23dc3545' viewBox='0 0 12 12'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e") center right 1.75rem/ calc(.75em + .375rem) calc(.75em + .375rem) no-repeat}`;
var Re = Object.defineProperty, He = Object.getOwnPropertyDescriptor, k = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? He(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && Re(t, e, o), o;
};
let w = class extends m {
  constructor() {
    super(...arguments), this.options = [], this.disabled = !1, this.size = "default", this.class = "", this.id = "", this.value = "", this.block = !1, this.valid = !1, this.invalid = !1;
  }
  static get styles() {
    return [N(Me)];
  }
  onChangeHandler(i) {
    var t;
    this.value = (t = i == null ? void 0 : i.target) == null ? void 0 : t.value, i.preventDefault(), i.stopPropagation(), this.dispatchEvent(
      new CustomEvent("change", {
        bubbles: !0,
        detail: this.value
      })
    );
  }
  render() {
    return y`
      <select ?disabled=${this.disabled} @change=${this.onChangeHandler}>
        <option ?selected=${this.value === ""} value="">Please pick..</option>
        ${Ue(
      this.options,
      (i) => y`<option
              value=${i.value}
              ?selected=${this.value === i.value}
              @click=${this.onChangeHandler}
            >
              ${i.label}
            </option>`
    )}
      </select>
    `;
  }
};
k([
  a({ type: Array, attribute: !0, reflect: !0 })
], w.prototype, "options", 2);
k([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], w.prototype, "disabled", 2);
k([
  a({ type: String, attribute: !0, reflect: !0 })
], w.prototype, "size", 2);
k([
  a({ type: String, attribute: !0, reflect: !0 })
], w.prototype, "class", 2);
k([
  a({ type: String, attribute: !0, reflect: !0 })
], w.prototype, "id", 2);
k([
  a({ type: String, attribute: !0, reflect: !0 })
], w.prototype, "value", 2);
k([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], w.prototype, "block", 2);
k([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], w.prototype, "valid", 2);
k([
  a({ type: Boolean, attribute: !0, reflect: !0 })
], w.prototype, "invalid", 2);
w = k([
  T("pf-select")
], w);
const Le = ":host([disabled]){cursor:not-allowed!important;pointer-events:none!important}:host([disabled]) div[disabled],:host([disabled]) div:disabled,:host([disabled]) div.disabled{opacity:.65!important;pointer-events:none!important;cursor:not-allowed!important}:host{display:var(--pf-display, inline-block);width:var(--pf-size, 1rem);height:var(--pf-size, 1rem);font-size:var(--pf-font-size, .75rem)}:host div{display:var(--pf-display, inline-block);width:100%;height:100%;vertical-align:-.125em;border-radius:50%}:host([variant=primary]) div{color:var(--pf-color, #007bff)}:host([variant=secondary]) div{color:var(--pf-color, #6c757d)}:host([variant=success]) div{color:var(--pf-color, #28a745)}:host([variant=danger]) div{color:var(--pf-color, #dc3545)}:host([variant=warning]) div{color:var(--pf-color, #ffc107)}:host([variant=info]) div{color:var(--pf-color, #17a2b8)}:host([variant=light]) div{color:var(--pf-color, #f8f9fa)}:host([variant=dark]) div{color:var(--pf-color, #343a40)}:host([type=border]) div{border:var(--pf-font-size, .25rem) solid currentcolor;border-right-color:transparent;border-radius:50%;-webkit-animation:.75s linear infinite spinner-border;animation:.75s linear infinite spinner-border}:host([type=grow]) div{background-color:currentcolor;opacity:0;-webkit-animation:.75s linear infinite spinner-grow;animation:.75s linear infinite spinner-grow}@keyframes spinner-border{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spinner-grow{0%{-webkit-transform:scale(0);transform:scale(0)}50%{opacity:1;-webkit-transform:none;transform:none}}";
var De = Object.defineProperty, je = Object.getOwnPropertyDescriptor, X = (i, t, e, r) => {
  for (var o = r > 1 ? void 0 : r ? je(t, e) : t, s = i.length - 1, n; s >= 0; s--)
    (n = i[s]) && (o = (r ? n(t, e, o) : n(o)) || o);
  return r && o && De(t, e, o), o;
};
let j = class extends m {
  constructor() {
    super(), this.variant = "primary", this.type = "border", this.class = "", this.id = "";
  }
  static get styles() {
    return [N(Le)];
  }
  render() {
    return y`<div></div>`;
  }
};
X([
  a({ type: String, attribute: !0, reflect: !0 })
], j.prototype, "variant", 2);
X([
  a({ type: String, attribute: !0, reflect: !0 })
], j.prototype, "type", 2);
X([
  a({ type: String, attribute: !0, reflect: !0 })
], j.prototype, "class", 2);
X([
  a({ type: String, attribute: !0, reflect: !0 })
], j.prototype, "id", 2);
j = X([
  T("pf-spinner")
], j);
export {
  R as Badge,
  x as Button,
  D as Checkbox,
  $ as Dropdown,
  f as Image,
  b as Input,
  w as Select,
  j as Spinner
};
